(* File: search.ml *)
(* Author: Chad E Brown *)
(* Created: October 2010 *)

open Flags
open State
open Syntax

val enable_pattern_clauses : bool ref

val preprocess : ftrma -> ftrma

val decompose : int -> stp -> ftrma list -> ftrma list -> Refut.ruleinfo option -> unit
val confront : int -> int -> ftrma -> ftrma -> int -> ftrma -> ftrma -> unit
val mate : int -> int -> stp -> ftrma list -> ftrma list -> ftrma list
val forall_rule : int -> int -> ftrma -> ftrma -> unit
val negforall_rule : int -> int -> ftrma -> unit
val process_unprocessed_prop : int -> ftrma -> unit

val search : unit -> unit
